#line 1 "D:/Norbert/Documents/Dropbox/aclasser/midiwah_src/crybaby_midi.c"







sbit LCD_RS at RB0_bit;
sbit LCD_EN at RB2_bit;
sbit LCD_D4 at RB3_bit;
sbit LCD_D5 at RB4_bit;
sbit LCD_D6 at RB5_bit;
sbit LCD_D7 at RB6_bit;
sbit LCD_RS_Direction at TRISB0_bit;
sbit LCD_EN_Direction at TRISB2_bit;
sbit LCD_D4_Direction at TRISB3_bit;
sbit LCD_D5_Direction at TRISB4_bit;
sbit LCD_D6_Direction at TRISB5_bit;
sbit LCD_D7_Direction at TRISB6_bit;



const char *msg[] = {
"Cry Baby MIDI v1",
"-----NB 2025----",
"----- TEST -----",
"canal:          ",
" V",
" F",
"  ",
"linear",
" log1 ",
" log2 ",
" log3 ",
"lead1 ",
"lead2 ",
"lead3 ",
"Mut/Bp"};

const int nbCourbe=8;
unsigned char step[nbCourbe][10] =
{
{0,40,70,100,130,155,185,210,234,255},
{40,150, 163,176,189,202,215,228,241,255},
{40,150, 180,200,210,220,230,240,248,255},
{40,170, 205,220,230,238,245,250,253,255},
{200,200, 200,200,200,200,255,255,255,255},
{210,210, 210,210,210,210,255,255,255,255},
{220,220, 220,220,220,220,255,255,255,255},
{0,0, 0,0,0,0,255,255,255,255}
};

int i;
unsigned char config;
unsigned char mode;
unsigned char canal;
unsigned char courbe;
unsigned char codeMidi;
unsigned char Msg_PC;
unsigned char Msg_CC;
char canalTxt[4];
char codeTxt[10];

unsigned char oldNVol=0;
unsigned char paramCC;




char* message(const char* ctxt)
{
static char txt[18];
char j;
for (j=0; txt[j]=ctxt[j]; j++);
return txt;
}

void affichercanal()
{
Lcd_Out(1, 1,message(msg[3]));
Lcd_Chr(1, 7, canalTxt[1]); Lcd_Chr(1, 8, canalTxt[2]);
}

void afficherCourbe()
{
Lcd_Out(1, 10,message(msg[7+courbe]));
}

void initialisation()
{
IRP_bit=0;

adcon1=6;
adcon0=0;
TRISA = 0x3F;

TRISB = 0;
Delay_ms(1000);
Lcd_Init();
Delay_ms(1000);
Lcd_Cmd(_Lcd_CURSOR_OFF);
Lcd_Cmd(_Lcd_CLEAR);

TRISD = 0x01;
PortD.F1 = 0;PortD.F2 = 0;

PWM1_Init(30000);

UART1_init(31250);
Delay_ms(100);

config=PortA;
canal=config & 0x0F;
courbe=(config & 0xF0)/16;
Msg_PC=192+canal;
Msg_CC=176+canal;
ByteToStr(canal+1,canalTxt);

Lcd_Out(1,1,message(msg[0]));
Lcd_out(2,1,message(msg[1]));
delay_ms(1000);
}

char* bargraph(int blocs)
{
static char txt[16]="--          --";
int i;
for (i=2;i<blocs+2;i++)txt[i]=0xFF;
for (i=blocs+2;i<12;i++)txt[i]=' ';
return txt;
}

void ChangeVol(int niveau)
{
int nbrBlocs;
int level;
if ((niveau>=0) && (niveau<24))
 {nbrblocs=1;level=step[courbe][0];}
else
if ((niveau>=24) && (niveau<48))
 {nbrblocs=2;level=step[courbe][1];}
else
if ((niveau>=48) && (niveau<72))
 {nbrblocs=3;level=step[courbe][2];}
else
if ((niveau>=72) && (niveau<96))
 {nbrblocs=4;level=step[courbe][3];}
else
if ((niveau>=96) && (niveau<120))
 {nbrblocs=5;level=step[courbe][4];}
else
if ((niveau>=120) && (niveau<144))
 {nbrblocs=6;level=step[courbe][5];}
else
if ((niveau>=144) && (niveau<168))
 {nbrblocs=7;level=step[courbe][6];}
else
if ((niveau>=168) && (niveau<192))
 {nbrblocs=8;level=step[courbe][7];}
else
if ((niveau>=192) && (niveau<216))
 {nbrblocs=9;level=step[courbe][8];}
else
if (niveau>=216)
 {nbrblocs=10;level=step[courbe][9];}
PWM1_Set_Duty(level);
Lcd_Out(2,1,bargraph(nbrBlocs));
}

void programChange()
{
 while (UART1_Data_Ready()==0);
 codeMidi=UART1_Read();
 switch(codeMidi)
 {
 case 0 :
 {
 PortD.F1 = ~(PortD.F1) ;
 if (PortD.F1)
 Lcd_Out(2,15,message(msg[4]));
 else
 Lcd_Out(2,15,message(msg[6]));
 break;
 }
 case 1 :
 {
 PortD.F2 = ~(PortD.F2) ;
 if (PortD.F2)
 Lcd_Out(2,15,message(msg[5]));
 else
 Lcd_Out(2,15,message(msg[6]));
 break;
 }
 }
}

void controlChange()
{
unsigned char NVol;
unsigned char cdg;
unsigned char paramCC2;
 cdg=0;
 while ((UART1_Data_Ready()==0) && (cdg<0xFF))
 cdg++;
 if (cdg==0xFF) return;
 paramCC=UART1_Read();
 switch (paramCC)
 {
 case 0x07 :
 {

 cdg=0;
 while ((UART1_Data_Ready()==0) && (cdg<0xFF))
 cdg++;
 if (cdg==0xFF) return;
 paramCC2=UART1_Read();
 NVol=paramCC2;
 NVol=NVol & 0xFC;
 if (NVol!=oldNVol)
 {
 oldNVol=NVol;
 ChangeVol(NVol*2);
 }
 break;
 }
 case 0x01 :
 {
 while (UART1_Data_Ready()==0);
 paramCC2=UART1_Read();
 switch(paramCC2)
 {
 case 0:
 {
 PortD.F2=0;
 Lcd_Out(1,14,message(msg[6]));
 break;
 }
 case 127:
 {
 PortD.F2=1;
 Lcd_Out(1,14,message(msg[5]));
 break;
 }
 default : break;
 }
 break;
 }
 case 0x00 :
 {
 while (UART1_Data_Ready()==0);
 paramCC2=UART1_Read();
 switch(paramCC2)
 {
 case 0:
 {
 PortD.F1=0;
 Lcd_Out(2,15,message(msg[6]));
 break;
 }
 case 127:
 {
 PortD.F1=1;
 Lcd_Out(2,15,message(msg[4]));
 break;
 }
 default : break;
 }
 break;
 }
 }
}

modeTest()
{
int i,j;
while(1)
{
Lcd_Out(1,1,message(msg[2]));

Lcd_Out(2,1,message(msg[9]));
for (i=0;i<4;i++)
{
 PortD.F1=~PortD.F1;
 PortD.F2=~PortD.F2;
 delay_ms(500);
}


Lcd_Out(1,1,message(msg[3]));
affichercanal();
afficherCourbe();

PWM1_Start();
for (i=0;i<255;i++)
{
 PWM1_Set_Duty(i);
 j=i/25;
 delay_ms(50);
 Lcd_Out(2,1,bargraph(j));
}
PWM1_stop();
}
}

void changerCourbe()
{
 delay_ms(200);
 while (portD.F0==0);
 courbe++;
 if (courbe>nbCourbe-1) courbe=0;
 afficherCourbe();
}

void modeRun()
{
Lcd_Out(1,1,message(msg[0]));
Lcd_Out(2,1,message(msg[1]));
delay_ms(1000);
affichercanal();
afficherCourbe();
PWM1_Start();
while (1)
{
 if (portD.F0==0) changerCourbe();
 if (UART1_Data_Ready())
 {
 codeMidi=UART1_Read();
 if (codeMidi==Msg_CC)
 {
 controlChange();
 }
 else
 if (codeMidi==Msg_PC)
 {
 programChange();
 }
 else UART1_write(codeMidi);
 }
}
PWM1_Stop();
}

void main()
{
initialisation();
mode=PortA & 0xF0;
delay_ms(1000);
if (PortD.F0==0)
 modeTest();
else
 modeRun();
}
